﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Infragistics_xamDataGrid_Problem
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    public partial class UserControl1 : UserControl
    {
        string DefaultGridSettings;
            List<Policy> Policies = new List<Policy>();

        public UserControl1()
        {

            InitializeComponent();

        }

        private void idgv_Loaded(object sender, RoutedEventArgs e)
        {
   
            // create some data to show

            Policies.Add(new Policy("Insured Name 1 - Line 1", DateTime.Parse("01/01/2009"),  1000000));

            Policies.Add(new Policy("Insured Name 2 - Line 1", DateTime.Parse("01/03/2008"),  1035));

            Policies.Add(new Policy("Insured Name 3 - Line 1", DateTime.Parse("01/02/2007"),  1087));

            //this.RestoreSettings(); // this placement doesn't work

            this.idgv.DataSource = this.Policies;

            //this.RestoreSettings(); // this placement works
        }

        private void idgv_FieldLayoutInitializing(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs e)
        {
            //this.RestoreSettings(); // this placement doesn't work
        }


        private void idgv_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            this.RestoreSettings(); // this placement works

        }

        private void igdv_FieldPositionChanged(object sender, Infragistics.Windows.DataPresenter.Events.FieldPositionChangedEventArgs e)
        {
            this.SaveSettings();
        }

        private void RestoreSettings()
        {
            this.DefaultGridSettings = this.idgv.SaveCustomizations();  // save a copy of the unmodified (default) grid settings for reset if necessary
            if (!string.IsNullOrEmpty(Properties.Settings.Default.GridConfiguration))
            {
                try
                {
                    this.idgv.LoadCustomizations(Properties.Settings.Default.GridConfiguration.ToString());
                }
                catch (Exception)
                {
                    // if something blows up there's nothing we can do about it so leave the user with the default grid layout
                    this.idgv.LoadCustomizations(this.DefaultGridSettings);
                }
            }

        }
        private void SaveSettings()
        {

            Properties.Settings.Default.GridConfiguration = this.idgv.SaveCustomizations();

            Properties.Settings.Default.Save();   // we'll do this here to keep it simple
        }


    }

      public class Policy
    {
        private  string insuredname;
        private DateTime inceptiondate;
        private double writtenpremium;

        public Policy(string InsuredName, DateTime InceptionDate, double WrittenPremium)
        {
            this.insuredname = InsuredName;
            this.inceptiondate = InceptionDate;
            this.writtenpremium = WrittenPremium;
        }

        public string InsuredName
        {
            get { return this.insuredname; }
            set { this.insuredname = value; }
        }
        public DateTime InceptionDate
        {
            get { return this.inceptiondate; }
            set { this.inceptiondate = value; }
        }
        public double WrittenPremium
        {
            get { return this.writtenpremium; }
            set { this.writtenpremium = value; }
        }


    }
}
